=== debian/changelog ===
gmsh (2.8.1.dfsg-1) unstable; urgency=low

  * [a9800c5] Imported Upstream version 2.8.1
  * [5736abd] Update patches, remove applied by upstream ones.

 -- Anton Gladky <gladk@debian.org>  Thu, 11 Jul 2013 23:41:26 +0200

gmsh (2.7.1.dfsg-3) unstable; urgency=low

  * [076cd51] Add missing header in libgmsh-dev package. (Closes: #713942)
  * [b2afc09] Use canonical VCS-field.
  * [4894563] Make the package arch-specific. 
              Exclude kfreebsd*, mip* and hurd*.

 -- Anton Gladky <gladk@debian.org>  Mon, 24 Jun 2013 22:20:42 +0200

gmsh (2.7.1.dfsg-2) unstable; urgency=low

  * [ed2b563] Update changelog, close bug.
  * [6713841] Add break/replaces to libgmsh2. (Closes: #710734)

 -- Anton Gladky <gladk@debian.org>  Sun, 02 Jun 2013 09:29:29 +0200

gmsh (2.7.1.dfsg-1) unstable; urgency=low

  [ Anton Gladky ]
  * [b5f0971] Imported Upstream version 2.7.1.dfsg
  * [d01d02d] Change Multi-Arch to foreign for libjava-gmsh2. (Closes: #707749)
  * [17c9976] Refresh patches.
  * [6a3e1d6] Move libjava-gmsh.so into libgmsh2.
  * [fe21681] Add header into onelab.py.
  * [9364837] Install onelab using pyinstall.

  [ Roland Stigge ]
  * [8c3f48c] Do not compile against slepc and petsc on powerpcspe. 
              (Closes: #708862)
  * [f7c38ed] Use multiarched python path.

 -- Anton Gladky <gladk@debian.org>  Thu, 30 May 2013 20:22:35 +0200
