## gmsh 2.8.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,6 @@
 option(ENABLE_BUILD_DYNAMIC "Build dynamically linked Gmsh binary" OFF)
 option(ENABLE_BUILD_ANDROID "Build Gmsh library for Android NDK" OFF)
 option(ENABLE_BUILD_IOS "Build Gmsh library for iOS (ARM)" OFF)
-option(ENABLE_BUILD_IOS_EMULATOR "Build Gmsh library for iOS emulator (x86)" OFF)
 option(ENABLE_CGNS "Enable CGNS mesh export" OFF)
 option(ENABLE_CAIRO "Enable Cairo to render fonts" ${DEFAULT})
 option(ENABLE_CHACO "Enable Chaco mesh partitioner" ${DEFAULT})
@@ -45,7 +44,6 @@
 option(ENABLE_FOURIER_MODEL "Enable Fourier geometrical models" OFF)
 option(ENABLE_GMM "Enable GMM linear algebra solvers" ${DEFAULT})
 option(ENABLE_GRAPHICS "Compile-in OpenGL graphics even if there is no GUI" OFF)
-option(ENABLE_OPTHOM "Enable optimization tool for high order meshes" ${DEFAULT})
 option(ENABLE_KBIPACK "Enable Kbipack for homology solver" ${DEFAULT})
 option(ENABLE_MATHEX "Enable MathEx expression parser" ${DEFAULT})
 option(ENABLE_MED "Enable MED mesh and post-processing file formats" ${DEFAULT})
@@ -61,6 +59,7 @@
 option(ENABLE_ONELAB "Enable OneLab solver interface" ${DEFAULT})
 option(ENABLE_ONELAB_METAMODEL "Enable OneLab metamodel" ${DEFAULT})
 option(ENABLE_OPENMP "Enable OpenMP" OFF)
+option(ENABLE_OPTHOM "Enable optimization tool for high order meshes" ${DEFAULT})
 option(ENABLE_OS_SPECIFIC_INSTALL "Use OS-specific (e.g. app bundle) install" ${DEFAULT})
 option(ENABLE_OSMESA "Use OSMesa for offscreen rendering" OFF)
 option(ENABLE_PARSER "Build the GEO file parser" ${DEFAULT})
@@ -82,7 +81,7 @@
 
 set(GMSH_MAJOR_VERSION 2)
 set(GMSH_MINOR_VERSION 8)
-set(GMSH_PATCH_VERSION 1)
+set(GMSH_PATCH_VERSION 2)
 set(GMSH_EXTRA_VERSION "" CACHE STRING "Gmsh extra version string")
 
 set(GMSH_VERSION "${GMSH_MAJOR_VERSION}.${GMSH_MINOR_VERSION}")
@@ -95,6 +94,7 @@
   Common/Gmsh.h Common/Context.h Common/GmshDefines.h Common/GmshMessage.h
     Common/VertexArray.h Common/Octree.h Common/OctreeInternals.h 
     Common/OS.h Common/StringUtils.h Common/OpenFile.h
+    Common/onelab.h Common/GmshSocket.h Common/onelabUtils.h
   Numeric/Numeric.h Numeric/GaussIntegration.h Numeric/polynomialBasis.h
     Numeric/JacobianBasis.h Numeric/bezierBasis.h Numeric/fullMatrix.h
     Numeric/simpleFunction.h Numeric/cartesian.h Numeric/ElementType.h
