=== Mesh/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,6 @@
     BoundaryLayers.cpp 
     BDS.cpp 
     HighOrder.cpp 
-      highOrderTools.cpp 
     meshPartition.cpp
     meshRefine.cpp
     multiscalePartition.cpp
