=== contrib/HighOrderMeshOptimizer/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
   OptHOM.cpp 
   OptHomRun.cpp 
   ParamCoord.cpp 
+  OptHomElastic.cpp
 )
 
 file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)
