=== wrappers/gmshpy/CMakeLists.txt ===
--- 
+++ 
@@ -62,7 +62,7 @@
 
 option(ENABLE_PYTHON_LIB_API "Export all C header files needed to build the python library" OFF)
 if(ENABLE_PYTHON_LIB_API)
-  set(GMSH_API ${GMSH_API} Geo/Curvature.h Mesh/Generator.h Mesh/highOrderTools.h
+  set(GMSH_API ${GMSH_API} Geo/Curvature.h Mesh/Generator.h 
       Mesh/meshGFaceLloyd.h Numeric/DivideAndConquer.h Post/PViewFactory.h
       Solver/linearSystemPETSc.h Fltk/FlGui.h Solver/functionSpace.h
       Solver/STensor43.h Solver/sparsityPattern.h Solver/SElement.h
@@ -121,6 +121,7 @@
   Numeric/BergotBasis.h
   Mesh/CenterlineField.h
   Geo/Curvature.h
+  Common/Options.h
   Mesh/directions3D.h
   Mesh/DivideAndConquer.h
   Mesh/Field.h
@@ -132,13 +133,15 @@
   Geo/GeomMeshMatcher.h
   Geo/GFaceCompound.h
   Geo/gmshLevelset.h
-  Mesh/highOrderTools.h
   Numeric/jacobiPolynomials.h
   Numeric/legendrePolynomials.h
+  Plugin/Plugin.h
   Solver/linearSystemPETSc.h
   Mesh/meshGFaceLloyd.h
   contrib/HighOrderMeshOptimizer/OptHomRun.h
+  contrib/HighOrderMeshOptimizer/OptHomElastic.h
   Post/PViewAsSimpleFunction.h
+  Post/PViewDataList.h
   Post/PViewFactory.h
   Numeric/pyramidalBasis.h
   Solver/SElement.h
