=== debian/changelog ===
gmsh (2.8.2+dfsg-1) unstable; urgency=low

  * [a53e9ee] Imported Upstream version 2.8.2+dfsg
  * [e7e8053] Refresh patches.
  * [27acc54] Update changelog.
  * [218a07d] Fix compilation of java-wrapper.

 -- Anton Gladky <gladk@debian.org>  Wed, 24 Jul 2013 15:07:42 +0200
